WeaponUp = LibStub("AceAddon-3.0"):NewAddon("WeaponUp", "AceEvent-3.0")
local self = WeaponUp

local items = 	{"Fishing Poles", --All Fishing Poles
				46106, --Argent Lance
				46069, --Alliance Lance
				46070, --Horde Lance
				37892, --Green Brewfest Stein
				32912, --Yellow Brewfest Stein
				33016, --Blue Brewfest Stein
				44731, --Bouquet of Ebon Roses
				22206} --Bouquet of Red Roses

function WeaponUp:OnEnable()
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
	self:RegisterEvent("UI_ERROR_MESSAGE")
	self:RegisterEvent("UNIT_EXITED_VEHICLE")
	self:RegisterEvent("EQUIPMENT_SWAP_FINISHED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self.db = LibStub("AceDB-3.0"):New("WeaponUpDB")
	if not self.db.char.name then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r No set detected. Please equip a gearset with the Equipment Manager or type /wu and the exact name of the gearset you want to use for this addon to work.")
	end
end

SLASH_WeaponUp1 = "/wu";
local function handler(msg, editbox)
	if msg and not (msg=="off" or msg=="on" or msg=="help" or msg=="dismount off" or msg=="dismount on" or msg=="")then 
		self.db.char.name = msg
		self.db.char.lastset = msg
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00WeaponUp:|r Current set |cff00ff00 %s|r", msg ))
	end
	if (msg=="off") then
		self.db.char.enable = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r |cffff0000Off|r")
	end
	if (msg=="on") then
		self.db.char.enable = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r |cff00ff00On|r")
	end
	if (msg=="dismount off") then
		self.db.char.dismount = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r Dismount |cffff0000Off|r")
	end
	if (msg=="dismount on") then
		self.db.char.dismount = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r Dismount |cff00ff00On|r")
	end
	if (msg=="help" or msg =="") then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r Version |cff00ff002.4.1|r")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r To enable or disable equips type /wu on or /wu off.")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r To enable or disable weapon re-equip on dismount type /wu dismount on or /wu dismount off.")
	end
end
SlashCmdList["WeaponUp"] = handler;


function WeaponUp:ADDON_LOADED(event, addon)
	if addon == "WeaponUp" then
		WeaponUpDB = WeaponUpDB
		self:SetScript( "OnUpdate", handler)
	end
end

		
function WeaponUp:PLAYER_REGEN_DISABLED(event)
	if not self.db.char.name or self.db.char.enable == false or UnitInVehicle("player") then
		return;
	end
	local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
	local secondaryHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))
	for i,v in pairs(items) do
		if IsEquippedItemType(v) or IsEquippedItem(v) then
			UseEquipmentSet(self.db.char.name)
		end
	end
	if not mainHandLink then 
		UseEquipmentSet(self.db.char.name)
	end
	if mainHandLink then
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(mainHandLink)
		if (itemRarity == 0 or itemRarity == 1) then --Gray and white level items
			UseEquipmentSet(self.db.char.name)
		end
	end
	if secondaryHandLink then
		local itemName2, itemLink2, itemRarity2, itemLevel2, itemMinLevel2, itemType2, itemSubType2, itemStackCount2, itemEquipLoc2, itemTexture2, itemSellPrice2 = GetItemInfo(secondaryHandLink)
		if self.db.char.oh ~= nil and (itemRarity2 == 0 or itemRarity2 == 1) then --Gray and white level items
			UseEquipmentSet(self.db.char.name)
		end
	end
end

function WeaponUp:COMBAT_LOG_EVENT_UNFILTERED(combatlogevent, ...)
	if not self.db.char.name or self.db.char.enable == false or UnitInVehicle("player") then
		return;
	end
	local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
	local secondaryHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))
	local sourceGUID = select(3, ...)
	local type = select(2, ...)
	local playerGUID = UnitGUID("player")	
	if (sourceGUID==playerGUID) and UnitAffectingCombat("player")then
		if (type == "SWING_DAMAGE" or type == "RANGE_DAMAGE" or type == "SPELL_DAMAGE" or type == "SWING_MISSED" or type == "RANGE_MISSED" or type == "SPELL_MISSED" or type == "SPELL_HEAL" ) then
			for i,v in pairs(items) do
				if IsEquippedItemType(v) or IsEquippedItem(v) then
					UseEquipmentSet(self.db.char.name);
				end
			end
			if not mainHandLink then 
				UseEquipmentSet(self.db.char.name);
			end
			if mainHandLink then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(mainHandLink)
				if (itemRarity == 0 or itemRarity == 1) then --Gray and white level items
					UseEquipmentSet(self.db.char.name);
				end
			end
			if secondaryHandLink then
			local itemName2, itemLink2, itemRarity2, itemLevel2, itemMinLevel2, itemType2, itemSubType2, itemStackCount2, itemEquipLoc2, itemTexture2, itemSellPrice2 = GetItemInfo(secondaryHandLink)
				if self.db.char.oh ~= nil and (itemRarity2 == 0 or itemRarity2 == 1) then --Gray and white level items
					UseEquipmentSet(self.db.char.name);
				end
			end
		end
	end
end	

function WeaponUp:CheckSet()
	for i,v in ipairs(items) do
		if IsEquippedItemType(v) or IsEquippedItem(v) then
			return;
		end
	end
	local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
	local secondaryHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))
	if mainHandLink then
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(mainHandLink)
			if not UnitAffectingCombat("player") and (itemRarity ~= nil or itemRarity ~= 0 or itemRarity ~= 1) then
				self.db.char.name = self.db.char.lastset
			end
	end
	if secondaryHandLink then
	local itemName2, itemLink2, itemRarity2, itemLevel2, itemMinLevel2, itemType2, itemSubType2, itemStackCount2, itemEquipLoc2, itemTexture2, itemSellPrice2 = GetItemInfo(secondaryHandLink)
			if not UnitAffectingCombat("player") and (itemRarity2 ~= nil or itemRarity2 ~= 0 or itemRarity2 ~= 1) then
				self.db.char.name = self.db.char.lastset
			end
	end
end

function WeaponUp:UNIT_INVENTORY_CHANGED(event, unit)
	if (unit ~= "player")  or self.db.char.enable == false then
		return;
	end
	WeaponUp:CheckSet()
end

function WeaponUp:PLAYER_ENTERING_WORLD(event)
	if self.db.char.enable == false then
		return;
	end
	WeaponUp:CheckSet()
end

function WeaponUp:EQUIPMENT_SWAP_FINISHED(event, ok, name)
	if self.db.char.enable == false then 
		return;
	end
	--if (ok == true) and UnitAffectingCombat("player") and self.db.char.name and not UnitInVehicle("player") then
		--RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Switched to weapons from set |cff00ff00 %s|r", name ), ChatTypeInfo["RAID_WARNING"] );
	--end
	self.db.char.lastset = name
end

function WeaponUp:UI_ERROR_MESSAGE(event, message)
	if self.db.char.enable == false or UnitAffectingCombat("player") then
		return
	end
	if message == "You must have a lance equipped." then
		EquipItemByName(46106)
		EquipItemByName(46069)
		EquipItemByName(46070)
	end
end

function WeaponUp:UNIT_EXITED_VEHICLE(event, unit)
	if not self.db.char.name or self.db.char.enable == false or UnitInVehicle("player") or unit ~= "player" then
		return;
	end
	if self.db.char.dismount == true and unit == "player" and not UnitAffectingCombat("player") then
		if IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070) then -- Was in an Argent vehicle
			UseEquipmentSet(self.db.char.name)
		end
	end
end

function WeaponUp:PLAYER_REGEN_ENABLED(event)
	if not self.db.char.name or self.db.char.enable == false or UnitInVehicle("player") then
		return;
	end	
	if self.db.char.dismount == true then
		if IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070) then -- Was in an Argent vehicle
			UseEquipmentSet(self.db.char.name)
		end
	end	
end	